import { useEffect, useRef, useState } from "react";
import { EntitySearchClass } from "./EntitySearchClass";
export const initialSearchState = {
  paging: {
    page: 0,
    size: 100,
    sort: null
  },
  data: [],
  loadStatus: {},
  params: {},
  resources: {}
};
export const useEntitySearch = props => {
  const [, setState] = useState(initialSearchState);
  const useFormGroupClassRef = useRef(new EntitySearchClass(props, setState));
  useEffect(() => {
    useFormGroupClassRef.current.init();
    return () => {
      useFormGroupClassRef.current.close();
    };
  }, []);
  const useFormGroupClass = useFormGroupClassRef.current;
  return useFormGroupClass.config;
};