import { useEffect, useRef, useState } from "react";
import { filter, Subject, takeUntil, tap } from "rxjs";
import { FormGroup } from "../../model";
export const useFormGroup = formGroup => {
  const [, state] = useState({});
  const formGroupRef = useRef(formGroup || new FormGroup({}));
  const setFormGroup$ = new Subject();
  const destroy$ = new Subject();
  useEffect(() => {
    setFormGroup$.pipe(takeUntil(destroy$), filter(formGroup => formGroup !== formGroupRef.current), tap(formGroup => {
      formGroupRef.current = formGroup;
      formGroupRef.current.dispatchStateFn = state;
    })).subscribe();
  }, []);
  return {
    formGroup: formGroupRef.current,
    setFormGroup: setFormGroup$.next.bind(setFormGroup$)
  };
};