"use strict";

exports.__esModule = true;
exports.useEntitySearch = exports.initialSearchState = void 0;

var _react = require("react");

var _EntitySearchClass = require("./EntitySearchClass");

const initialSearchState = {
  paging: {
    page: 0,
    size: 100,
    sort: null
  },
  data: [],
  loadStatus: {},
  params: {},
  resources: {}
};
exports.initialSearchState = initialSearchState;

const useEntitySearch = props => {
  const [, setState] = (0, _react.useState)(initialSearchState);
  const useFormGroupClassRef = (0, _react.useRef)(new _EntitySearchClass.EntitySearchClass(props, setState));
  (0, _react.useEffect)(() => {
    useFormGroupClassRef.current.init();
    return () => {
      useFormGroupClassRef.current.close();
    };
  }, []);
  const useFormGroupClass = useFormGroupClassRef.current;
  return useFormGroupClass.config;
};

exports.useEntitySearch = useEntitySearch;