"use strict";

exports.__esModule = true;
exports.ModuleUtils = void 0;

/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */

/**
 * Determine if the argument is shaped like a Promise
 */
let ModuleUtils;
exports.ModuleUtils = ModuleUtils;

(function (_ModuleUtils) {
  function isPromise(obj) {
    // allow any Promise/A+ compliant thenable.
    // It's up to the caller to ensure that obj.then conforms to the spec
    return !!obj && typeof obj.then === 'function';
  }

  _ModuleUtils.isPromise = isPromise;

  function isSubscribable(obj) {
    return !!obj && typeof obj.subscribe === 'function';
  }

  _ModuleUtils.isSubscribable = isSubscribable;
  const isObservable = _ModuleUtils.isObservable = isSubscribable;
})(ModuleUtils || (exports.ModuleUtils = ModuleUtils = {}));